-- View: idm_rpt_data.idmrpt_user_status_v

-- DROP VIEW idm_rpt_data.idmrpt_user_status_v;

CREATE OR REPLACE VIEW idm_rpt_data.idmrpt_user_status_v AS 

SELECT DISTINCT event_data.identity_id,
event_data.first_name,
    event_data.middle_initial,
    event_data.last_name,
    event_data.event_datetime,
        CASE
            WHEN event_data.rv43::text ~~ '<%'::text THEN ''::text
            ELSE ' : '::text || event_data.rv43::text
        END AS rv43,
        CASE
            WHEN event_data.message::text ~~ '%0029006A%'::text THEN event_data.message::text
            ELSE split_part(event_data.message::text, ':'::text, 1)
        END AS message,
    event_data.xdas_taxonomy_name,
    event_data.event_name AS event,
        CASE
            WHEN event_data.event_id::text = '00031411'::text THEN event_data.event_datetime
            ELSE date_trunc('minute'::text, event_data.event_datetime)
        END AS time_stamp,
    event_data.event_id,
        CASE
            WHEN btrim(event_data.idv_host::text) = btrim(event_data.idv_name::text) THEN event_data.idv_name::text
            ELSE ((event_data.idv_name::text || ' ('::text) || event_data.idv_host::text) || ')'::text
        END AS idv_name
   FROM idm_rpt_data.idmrpt_user_events_v2 event_data
WHERE
(
(event_id='0003000C' and (xdas_provider=0 and xdas_registry=0 and xdas_class=3 and xdas_identifier=3) )--Move Object
--provider=0 and registry=0 and class=3 and identifier=3 and xdas_taxonomy_name='XDAS_AE_MODIFY_DATA_ITEM_ATT'

--OR
--(event_id='0003000A' and xdas_taxonomy_id='101603' and event_target_user_name is not null)--Modify Object
OR
(event_id='0003000B' and (xdas_provider=0 and xdas_registry=0 and xdas_class=3 and xdas_identifier=3))-- Rename user name in Imanager
--iManager event_id='0003000B' and provider=0 and registry=0 and class=3 and identifier=3 and xdas_taxonomy_name='XDAS_AE_MODIFY_DATA_ITEM_ATT'

OR
(event_id='00031400' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=1))-- Subscriber Delete Entry
OR
(event_id='00030009' and xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=1 and xdas_taxonomy_name='XDAS_AE_DELETE_ACCOUNT')

OR
(event_id='0003002B' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5))-- Subscriber Remove Value
--provider=0 and registry=0 and class=0 and identifier=5 and xdas_taxonomy_name='XDAS_AE_MODIFY_ACCOUNT'

OR
(event_id='00030016' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5) and rv43 = 'true')-- login disabled
--iManager event_id='0003002A' and provider=0 and registry=0 and class=0 and identifier=5 and xdas_taxonomy_name='XDAS_AE_MODIFY_ACCOUNT' and rv43='true'

OR
(event_id='00030015' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5) and rv43 = 'false')-- login enabled
--iManager event_id='0003002A' and provider=0 and registry=0 and class=0 and identifier=5 and xdas_taxonomy_name='XDAS_AE_MODIFY_ACCOUNT' and rv43='false'

OR
(event_id='000B0224' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=8))
--provider=0 and registry=0 and class=0 and identifier=8 and xdas_taxonomy_name='XDAS_AE_REVOKE_ACCOUNT_ACCESS'

OR
(event_id='000B0225' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=8))
--provider=0 and registry=0 and class=0 and identifier=8 and xdas_taxonomy_name='XDAS_AE_REVOKE_ACCOUNT_ACCESS'

OR
(event_id='00031411' AND xdas_provider = 0 AND xdas_registry = 0 AND xdas_class = 0 AND xdas_identifier = 6)--Change password from left panel
--iManager event_id='0003000B' and provider=0 and registry=0 and class=0 and identifier=6 and xdas_taxonomy_name='XDAS_AE_SET_CRED_ACCOUNT'

OR
(event_id='00031660' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5))--Modify user info
--iManager
OR
(event_id='0003000A' and xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5 and xdas_taxonomy_name='XDAS_AE_MODIFY_ACCOUNT' and event_source_user IS NOT NULL)

OR
(event_id='00031674' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=5))--Modify user info
--iManager event_id='0003000A' and provider=0 and registry=0 and class=0 and identifier=5 and xdas_taxonomy_name='XDAS_AE_MODIFY_ACCOUNT' and event_source_user IS NOT NULL

OR
(event_id='00031401' and (xdas_provider=0 and xdas_registry=0 and xdas_class=4 and xdas_identifier=3))--Rename user login name
--provider=0 and registry=0 and class=4 and identifier=3 and xdas_taxonomy_name='XDAS_AE_QUERY_SERVICE_CONFIG'

OR
(event_id='0003000C' and (xdas_provider=0 and xdas_registry=0 and xdas_class=4 and xdas_identifier=3))--Move object to different domain
--provider=0 and registry=0 and class=4 and identifier=3 and xdas_taxonomy_name='XDAS_AE_QUERY_SERVICE_CONFIG'

OR
(event_id is null  AND xdas_provider = 0 AND xdas_registry = 0 AND xdas_class = 0 AND xdas_identifier = 6)--Password change from home icon
--provider=0 and registry=0 and class=0 and identifier=6 and xdas_taxonomy_name='XDAS_AE_SET_CRED_ACCOUNT'

OR
(event_id='00031440' and (xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=0))--Create user from both idm and iManager
--idm creation 
OR
(event_id='00030008' and xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=0 and xdas_taxonomy_name='XDAS_AE_CREATE_ACCOUNT')

--(event_id='00031440' and xdas_taxonomy_id='101201')--Create user,removed b/c it is only picking the iManager
OR
(event_id='0029006A'  AND xdas_provider = 0 AND xdas_registry = 0 AND xdas_class = 0 AND xdas_identifier = 6)-- password change through iManager Admin Set Password
--provider=0 and registry=0 and class=0 and identifier=6 and xdas_taxonomy_name='XDAS_AE_SET_CRED_ACCOUNT'
OR
(event_id='00030012' AND xdas_provider=0 and xdas_registry=0 and xdas_class=0 and xdas_identifier=6 and xdas_taxonomy_name='XDAS_AE_SET_CRED_ACCOUNT')
OR
(event_id='00030001' AND xdas_provider=0 and xdas_registry=0 and xdas_class=1 and xdas_identifier=4 and xdas_taxonomy_name='XDAS_AE_QUERY_TRUST')
)
   ORDER BY event_data.event_datetime;

ALTER TABLE idm_rpt_data.idmrpt_user_status_v
  OWNER TO idm_rpt_data;
GRANT ALL ON TABLE idm_rpt_data.idmrpt_user_status_v TO idm_rpt_data;
GRANT SELECT ON TABLE idm_rpt_data.idmrpt_user_status_v TO idmrptuser;